export function Cartesian(fD , id){ // function to handle cartesian.
  

			var data = fD;
			var titles = Object.keys(data[0]);
  
  		var maxX = Math.max.apply(Math, data.map(function(o) { return o[titles[0]]; }))
      var maxY = Math.max.apply(Math, data.map(function(o) { return o[titles[1]]; }))
      maxX = Math.ceil(maxX / 10) * 10;
   		maxY = Math.ceil(maxY / 10) * 10;

      var margin = {
        top: 60,
        right: 30,
        bottom: 30,
        left: 50
      };
      var width = 500 - margin.left - margin.right;
      var height = 500 - margin.top - margin.bottom;

      // create the svg container
      var svg = d3.select(id).append("svg")
        .attr("width", width + margin.left + margin.right)
        .attr("height", height + margin.top + margin.bottom)
        .append("g")
        .attr("transform", "translate(" + margin.left + "," + margin.top + ")");

      // set up the x scale
      var xScale = d3.scaleLinear()
        .domain([-maxX, maxX])
        .range([0, width]); // actual length of axis

      // set up the y scale
      var yScale = d3.scaleLinear()
        .domain([-maxY, maxY])
        .range([height, 0]); // actual length of axis


      // define the x axis
      var xAxis = d3.axisBottom(xScale);

      // define the y axis
      var yAxis = d3.axisLeft(yScale);

      // call the xAxis function to generate the x axis 
      svg.append("g")
        .attr("class", "axis") // assign an axis class
        .attr("transform", "translate(0, " + (height / 2) + ")")
        .call(xAxis);

      // call the yAxis function to generate the x axis 
      svg.append("g")
        .attr("class", "axis") // assign an axis class
        .attr("transform", "translate(" + width / 2 + ", 0)")
  			.call(yAxis);

  
  		// append a circle
  		svg.selectAll("dot")
        .data(data)
      .enter().append("circle")
        .attr("r", 3.5)
        .attr("cx", function(d) { return xScale(d[titles[0]]); })
        .attr("cy", function(d) { return yScale(d[titles[1]]); })
  			.style("fill", "red");
};
        