export function Continuum(fD , id){ // function to handle Continumm.
  
   	var height = 520;
    var width = 680;
		var title = fD[0];
  	var myData = fD.slice(1, fD.length);
  	
    var categories = myData.length;
    var data = d3.range(categories).map(()=>1);
  	//console.log(myData);

    var svg = d3.select(id)
      .append('svg')
      .attr('width', width)
      .attr('height', height);

    var graphGroup = svg.append('g')
      .attr('transform', "translate(350,350)");

    var pie = d3.pie()
      .startAngle(-Math.PI/2)
      .endAngle(Math.PI/2);

    var outerRadius = 300;
    var innerRadius = 100;

    var arc = d3.arc()
      .innerRadius(innerRadius)
      .outerRadius(outerRadius);

  	let i=-1;
  	let k=0;
  
  	const colorScale = d3.scaleLinear();
  	colorScale.domain([1,categories]).range(['lime','red']);
  
    var path = graphGroup.selectAll(null)
      .data(pie(data))
      .enter()
    	.append('path')
      .attr("d", arc)
      .style('stroke', '#000')
      .style('stroke-width', "2px")
      .style('fill', function(d) { k++; return colorScale(k);})
    	.attr("id", function(d) { i++; return "path" + i;})
    	.each(drawArc);
  	
  	// k=0;
  	// var path2 = graphGroup.selectAll(null)
  	// .data(pie(data))
  	// .enter()
  	// .append('path')
  	// .attr("d", function(d){
  	// return arc.innerRadius(outerRadius)
  	// .outerRadius(230)(d)
  	// })
  	// .style('stroke', '#000')
  	// .style('stroke-width', "2px")
  	// .attr("id", function(d) { i++; return "path" + i;})
  	// .style('fill', function(d) { k++; return colorScale(k);})
  	// .each(drawArc2);
  
  function drawArc(d, j) {
  		var text = graphGroup.append("text")
      .attr("x", 20)
      .attr("dy", 80);

      text.append("textPath")
        .style("font", "1.3em Calibri")
        .attr("xlink:href","#path" + j)
        .text(myData[j]);
  }
//   function drawArc2(d, j) {
//     	j=j+categories;
//   		var text2 = graphGroup.append("text")
//       .attr("x", 20)
//       .attr("dy", 40);

//       text2.append("textPath")
//         .style("font", "24px Calibri")
//         .attr("xlink:href","#path" + j)
//         .text("asdasxa sxas");
//   }
  
  
  //Append a defs (for definition) element to your SVG
  var defs = svg.append("defs");
  var linearGradient = defs.append("linearGradient")
    .attr("id", "linear-gradient");
  
	linearGradient.append("stop")
    .attr("offset", "0%")
    .attr("stop-color", "lime"); 

	linearGradient.append("stop")
    .attr("offset", "100%")
    .attr("stop-color", "red"); 

	var tri = d3.symbol().type(d3.symbolTriangle).size(1200);
  svg.append("path")
    .attr("d", tri)
    .attr("transform", "translate(600,400)rotate(90)")
  	.style("fill", "red");
  svg.append("path")
    .attr("d", tri)
    .attr("transform", "translate(100,400)rotate(-90)")
  	.style("fill", "lime");
	svg.append("rect")
    .attr("width", 480)
    .attr("height", 40)
  	.attr("x", 110)
    .attr("y", 380)
    .style("fill", "url(#linear-gradient)");
  
  svg.append("text")
        .style("font", "2em Calibri")
        .attr("x", 210)
        .attr("y", 450)
        .text(title);

}