export function Cycle(fD , id ){ // function to handle Cycle.

		var data = fD,
      width = 700,
      height = 700,
      c = Math.min(width, height) / 2,
      ro = Math.min(width, height) / 2 - (c * .3),
      ri = Math.min(width, height) / 2 - (c * .6),
      a = (Math.PI * 2) / data.length,
      colors = d3.scaleOrdinal(d3.schemeCategory10);

    

    var arc = d3.arc()
      .innerRadius(ri)
      .outerRadius(ro);

  	var tip = d3.tip()
      .attr('class', 'd3-tip')
      .direction('w')
      .html(function(d) {
        return d.children.join(" ")
      });
  	
    var svg = d3.select(id)
      .append('svg')
      .attr('width', width)
      .attr('height', height)
      .call(tip);

    svg = svg.append('g')
      .attr('transform', 'translate(' + c + ',' + c + ')')

    var arcs = svg.selectAll('.cycle')
      .data(data);

    var arcsG = arcs.enter()
      .append('g')
      .attr('class', 'cycle');

    arcsG
      .append("path")
      .attr('class', 'cycle')
      .style('fill', function(d, i) {
        return colors(i);
      })
      .attr("id", function(d) {
        return "path" + d.label;
      })
      .attr("d", function(d, i) {

        arc.startAngle(a * i);
        arc.endAngle(a * (i + 1));
        d.centroid = arc.centroid();

        return arc();
      })
      .on('mouseover', tip.show)
      .on('mouseout', tip.hide);

    arcsG
      .append("text")
      .attr("transform", function(d) {
        return "translate(" + d.centroid + ")";
      })
      .text(function(d) {
        return d.label;
      })
      .style("fill", "white")
      .style("text-anchor", "middle")
      .style("alignment-baseline", "middle")
      .style("pointer-events", "none");

    // draw arrow heads last so they end up on top
    arcs
      .enter()
      .append('polygon')
      .attr("points", function(d, i) {
        var sta = a * i,
          spa = a * (i + 1);
        // determine points for arrowhead
        var arrowHead = [Math.cos(spa - Math.PI / 2) * (ri - 15), Math.sin(spa - Math.PI / 2) * (ri - 15)] + ' ';
        arrowHead += [Math.cos(spa - Math.PI / 2) * (ro + 15), Math.sin(spa - Math.PI / 2) * (ro + 15)] + ' ';
        arrowHead += [Math.cos(spa - Math.PI / 2 + ((spa - sta) / 4)) * (ri + (ro - ri) / 2), Math.sin(spa - Math.PI / 2 + ((spa - sta) / 4)) * (ri + (ro - ri) / 2)];

        return arrowHead;
      })
      .style("fill", function(d, i) {
        return colors(i);
      })
      .style("stroke", function(d, i) {
        return colors(i);
      });
  
}