import { load } from './dataflowHead.js';

export function dataFlow(fD , id ){ // function to handle dataFlow.
  
  var div = d3.select(id)
      .append('div')
  		.attr('id', "datafloww");

	div.append("div")
    .attr('id', "myDiagramDiv")
		.style('border', "solid 1px black")
		.style('width', "80%")
		.style('height', "460px")
		.style('background', "whitesmoke");

	var div2 = div.append("div");

  div2.append("input")
    .attr( 'type', 'button')
		.attr( 'value', 'draw')
		.on("click", load);

	div2.append("text")
  	.html( ' Diagram Model data in JSON format:');
	

	div.append("foreignObject")
    .append("xhtml:body")
    .attr('xmlns','http://www.w3.org/1999/xhtml')
    .append('textarea')
		.property('value',
             `{ "class": "go.GraphLinksModel",
          "nodeKeyProperty": "id",
          "nodeDataArray": [
          {"id":0, "loc":"190 15", "text":"Shopping"},
          {"id":1, "loc":"353 32", "text":"Browse Items"},
          {"id":2, "loc":"353 166", "text":"Search Items"},
          {"id":3, "loc":"512 12", "text":"View Item"},
          {"id":4, "loc":"661 17", "text":"View Cart"},
          {"id":5, "loc":"644 171", "text":"Update Cart"},
          {"id":6, "loc":"800 96", "text":"Checkout"}
          ],
          "linkDataArray": [
            { "from": 0, "to": 1,  "progress": "true", "text": "Browse" },
            { "from": 0, "to": 2,  "progress": "true", "text": "Use search bar" },
            { "from": 1, "to": 2,  "progress": "true", "text": "Use search bar" },
            { "from": 2, "to": 3,  "progress": "true", "text": "Click item" },
            { "from": 2, "to": 2,  "text": "Another search", "curviness": 20 },
            { "from": 1, "to": 3,  "progress": "true", "text": "Click item" },
            { "from": 3, "to": 0,  "text": "Not interested", "curviness": -100 },
            { "from": 3, "to": 4,  "progress": "true", "text": "Add to cart" },
            { "from": 4, "to": 0,  "text": "More shopping", "curviness": -150 },
            { "from": 4, "to": 5,  "text": "Update needed", "curviness": -50 },
            { "from": 5, "to": 4,  "text": "Update made" },
            { "from": 4, "to": 6,  "progress": "true", "text": "Proceed" },
            { "from": 6, "to": 5,  "text": "Update needed" }
          ]
        }`
             )
    .style("font-size" , "12px")
		.attr('id','mySavedModel')
		.attr('rows','10')
		.style('width','80%')
		.style('height','300px');

  
}
