export function histoGram(fD , id , titles){ // function to handle histogram.
      	var barColor = 'steelblue';
        var hG={},    hGDim = {t: 60, r: 0, b: 30, l: 80};
        hGDim.w = 700 - hGDim.l - hGDim.r, 
        hGDim.h = 480 - hGDim.t - hGDim.b;
        console.log(titles);
        //create svg for histogram.
        var hGsvg = d3.select(id).append("svg")
            .attr("width", hGDim.w + hGDim.l + hGDim.r)
            .attr("height", hGDim.h + hGDim.t + hGDim.b + 40).append("g")
            .attr("transform", "translate(" + hGDim.l + "," + hGDim.t + ")");

        // create function for x-axis mapping.
        var x = d3.scaleBand().rangeRound([0, hGDim.w], 0.1)
                .domain(fD.map(function(d) { return d[0]; }));

      	var y = d3.scaleBand().rangeRound([0, hGDim.h], 0.1)
                .domain(fD.map(function(d) { return d[0]; }));
      	
        // Add x-axis to the histogram svg.
        hGsvg.append("g").attr("class", "x axis")
            .attr("transform", "translate(0," + hGDim.h + ")")
            .call(d3.axisBottom(x));

				// text label for the x axis
        hGsvg.append("text")             
            .attr("transform", "translate(" + (hGDim.w/2) + " ," + (hGDim.h + 50) + ")")
            .style("text-anchor", "middle")
            .text(titles[0]);

  
        // Create function for y-axis map.
        var y = d3.scaleLinear().range([hGDim.h, 0])
                .domain([0, d3.max(fD, function(d) { return d[1]; })]);

        // Add y-axis to the histogram svg.
        hGsvg.append("g").attr("class", "y axis")
            .attr("transform", "translate(0," + 0 + ")")
            .call(d3.axisLeft(y));
  
        // text label for the y axis
        hGsvg.append("text")
            .attr("transform", "rotate(-90)")
            .attr("y", 0 - hGDim.l+20)
            .attr("x",0 - (hGDim.h / 2))
            .attr("dy", "1em")
            .style("text-anchor", "middle")
            .text(titles[1]);         
  
  
        // Create bars for histogram to contain rectangles and freq labels.
        var bars = hGsvg.selectAll(".bar").data(fD).enter()
                .append("g").attr("class", "bar");
				
        //create the rectangles.
        bars.append("rect")
  					.attr('id','recti')
            .attr("x", function(d) { return x(d[0]); })
            .attr("y", function(d) { return y(d[1]); })
            .attr("width", x.bandwidth())
            .attr("height", function(d) { return hGDim.h - y(d[1]); })
            .attr('fill',barColor);

        //Create the frequency labels above the rectangles.
        bars.append("text").text(function(d){ return d3.format(",")(d[1])})
            .attr("x", function(d) { return x(d[0])+x.bandwidth()/2; })
            .attr("y", function(d) { return y(d[1])-5; })
            .attr("text-anchor", "Mediumdle");
        
  
				
        return hG;
}