export function hyperbolicTree(fD , id ){ // function to handle hyperbolicTree.
    
  	var vWidth = 500;
    var vHeight = 400;

  	// append the svg object to the body of the page
    var svg = d3.select(id).append("svg");
    var gg = svg.append("g");

  
    // Prepare our physical space
    var g = svg.attr('width', vWidth).attr('height', vHeight)
        .select('g').attr('transform', 'translate(' + vWidth/2 + ',' + vHeight/2 + ')');

    // Get the data from our CSV file
    var vCsvData = fD;

    var vData = d3.stratify()(vCsvData);
    drawViz(vData);

    function drawViz(vData) {
        // Declare d3 layout
        var vLayout = d3.cluster().size([2 * Math.PI, Math.min(vWidth, vHeight)/2 - 10]); // margin!

        // Layout + Data
        var vRoot = d3.hierarchy(vData);
        var vNodes = vRoot.descendants();
        var vLinks = vLayout(vRoot).links();

        // Draw on screen
        g.selectAll('path').data(vLinks).enter().append('path').attr("id","pathz")
            .attr('d', d3.linkRadial()
                .angle(function (d) { return d.x; })
                .radius(function (d) { return d.y; }));

        g.selectAll('circle').data(vNodes).enter().append('circle').attr("id","circlez")
            .attr('r', 10)
            .attr("transform", function (d) {  return "translate(" + d3.pointRadial(d.x, d.y) + ")"; });
      
      	g.append('g').selectAll('text')
  					.data(vNodes)
      			.enter().append('text')
            .attr("dy", function(d){return (d3.pointRadial(d.x, d.y)[1]-15)})
            .attr("dx", function(d){return (d3.pointRadial(d.x, d.y)[0])})
            .style("text-anchor", "middle")
            .text(function (d) {console.log(d); return d.data.id }); 

    }
  
}

