export function layerChart(fD , id){ // function to handle layerChart.
  
  
  d3.select(id).append("div")
  			.attr( 'id', 'mapid');
  // Initialize the map
  // [50, -0.1] are the latitude and longitude
  // 4 is the zoom
  // mapid is the id of the div where the map will appear
  var map = L
    .map('mapid')
    .setView([33, 54], 5);

  // Tile type: openstreetmap normal
  var openstreetmap = L.tileLayer(
    'https://{s}.tile.openstreetmap.org/{z}/{x}/{y}.png', {
    attribution: 'Map data &copy; <a href="https://www.openstreetmap.org/">OpenStreetMap</a>',
    maxZoom: 6
  })

  // Tile type: openstreetmap Hot
  var openstreetmapHot = L.tileLayer(
    'http://{s}.tile.openstreetmap.fr/hot/{z}/{x}/{y}.png', {
    attribution: 'Map data &copy; <a href="https://www.openstreetmap.org/">OpenStreetMap</a>',
    maxZoom: 6
  })

  // Tile type: openstreetmap Osm
  var openstreetmapOsm = L.tileLayer(
    'http://{s}.tile.openstreetmap.fr/osmfr/{z}/{x}/{y}.png', {
    attribution: 'Map data &copy; <a href="https://www.openstreetmap.org/">OpenStreetMap</a>',
    maxZoom: 6
  })

  //Base layers definition and addition
  var allOptions = {
    "Open streetmap": openstreetmap,
    "Open streetmap: Hot": openstreetmapHot,
    "Open streetmap: Osm": openstreetmapOsm
  };

  // Initialize with openstreetmap
  openstreetmap.addTo(map);

  // Add baseLayers to map as control layers
  L.control.layers(allOptions).addTo(map);
  
}
 