export function parallelCoor(fD , id ){ // function to handle parallelCor.

    var margin = {top: 80, right: 10, bottom: 10, left: 20},
        width = 960 - margin.left - margin.right,
        height = 500 - margin.top - margin.bottom;


  
    var x = d3.scalePoint().range([0, width]).padding(.1),
        y = {},
        dragging = {};

    var line = d3.line(),
        background,
        foreground;

    var svg = d3.select(id).append("svg").attr('id',"svgp")
        .attr("width", width + margin.left + margin.right)
        .attr("height", height + margin.top + margin.bottom)
      .append("g")
        .attr("transform", "translate(" + margin.left + "," + margin.top + ")");
  
  var dimensions;
  
  	  Promise
      .all([
        d3.csv(fD),
      ])
      .then(([cars]) => {

      console.log(cars);
        
      
      // Extract the list of dimensions and create a scale for each.
      x.domain(dimensions = d3.keys(cars[0]).filter(function(d) {
        return d != "name" && (y[d] = d3.scaleLinear()
            .domain(d3.extent(cars, function(p) { return +p[d]; }))
            .range([height, 0]));
      }));

      // Add grey background lines for context.
      var background = svg.append("g")
          .attr("class", "background")
        .selectAll("path")
          .data(cars)
        .enter().append("path")
          .attr("d", path);

      // Add blue foreground lines for focus.
      var foreground = svg.append("g")
          .attr("class", "foreground")
        .selectAll("path")
          .data(cars)
        .enter().append("path")
          .attr("d", path);

      // Add a group element for each dimension.
      var g = svg.selectAll(".dimension")
          .data(dimensions)
        .enter().append("g")
          .attr("class", "dimension")
          .attr("transform", function(d) { return "translate(" + x(d) + ")"; })
          .call(d3.drag()
            .subject(function(d) { return {x: x(d)}; })
            .on("start", function(d) {
              dragging[d] = x(d);
              background.attr("visibility", "hidden");
            })
            .on("drag", function(d) {
              dragging[d] = Math.min(width, Math.max(0, d3.event.x));
              foreground.attr("d", path);
              dimensions.sort(function(a, b) { return position(a) - position(b); });
              x.domain(dimensions);
              g.attr("transform", function(d) { return "translate(" + position(d) + ")"; })
            })
            .on("end", function(d) {
              delete dragging[d];
              transition(d3.select(this)).attr("transform", "translate(" + x(d) + ")");
              transition(foreground).attr("d", path);
              background
                  .attr("d", path)
                .transition()
                  .delay(500)
                  .duration(0)
                  .attr("visibility", null);
            	})
          	);

      // Add an axis and title.
      g.append("g")
          .attr("class", "axisp")
          .each(function(d) { d3.select(this).call(d3.axisLeft(y[d])); })
        .append("text")
          .style("text-anchor", "middle")
          .attr("y", -9)
          .text(function(d) { return d; });

      // Add and store a brush for each axis.
      g.append("g")
          .attr("class", "brush")
          .each(function(d) {
            d3.select(this).call(y[d].brush = d3.brushY(y[d]).extent([[-10,0], [10,height]]).on("start", brushstart).on("brush", brush));
                                 //d3.brushY(y[d]).on("start", brushstart).on("brush", brush));
        									//.extent([[y[d].range()[0], 0], [y[d].range()[1], height]])
          })
        .selectAll("rect")
          .attr("x", -8)
          .attr("width", 16);
        
        function brushstart() {
          d3.event.sourceEvent.stopPropagation();
        }

        // Handles a brush event, toggling the display of foreground lines.
        function brush() {
          var actives = dimensions.filter(function(p) { 
            if (y[p].brush.extent() === null) 
              return true;
            else
              return false;
            //return !y[p].brush.empty(); 
          }),
              extents = actives.map(function(p) { return y[p].brush.extent(); });
          foreground.style("display", function(d) {
            return actives.every(function(p, i) {
              return extents[i][0] <= d[p] && d[p] <= extents[i][1];
            }) ? null : "none";
          });
        }
    });

    function position(d) {
      var v = dragging[d];
      return v == null ? x(d) : v;
    }

    function transition(g) {
      return g.transition().duration(500);
    }

    // Returns the path for a given data point.
    function path(d) {
      return line(dimensions.map(function(p) { return [position(p), y[p](d[p])]; }));
    }

    
}