export function petriNet(fD , id ){ // function to handle petriNet.

  var  AND, active, all, box_color, circs, click_color, color, dead_color, force, height, holds, incoming, json, links, live_color, node, outgoing, radius, rects, svg, tasks, texts, width;

  width = 500;
  height = 500;
  
  svg = d3.select(id)
      .append('svg')
      .attr('width', width)
      .attr('height', height);
  


  color = d3.scaleOrdinal(d3.schemeCategory10);

  json = fD;
  
  
  
  force = d3.forceSimulation(json.nodes)
  	.force("charge", d3.forceManyBody().strength(-250))
		.force("link", d3.forceLink(json.edges).distance(45))
  	.force("center", d3.forceCenter(width / 2, height / 2))
  	.force("x", d3.forceX())
  	.force("y", d3.forceY());

  
	function dragstarted(d) {
  if (!d3.event.active) force.alphaTarget(0.3).restart()
      force.fix(d);
    }

    function dragged(d) {
      force.fix(d, d3.event.x, d3.event.y);
    }

    function dragended(d) {
      if (!d3.event.active) force.alphaTarget(0);
      force.unfix(d);
    }
  
    var drag = d3.drag().on('drag', function() {

    });
  
  
  AND = function(a, b) {
    return a && b;
  };

  all = function(xs) {
    return xs.length && xs.reduce(AND, true);
  };

  incoming = function(n) {
    var e, _i, _len, _ref, _results;
    _ref = json.edges;
    _results = [];
    for (_i = 0, _len = _ref.length; _i < _len; _i++) {
      e = _ref[_i];
      if (e.target === n) {
        _results.push(e);
      }
    }
    return _results;
  };

  outgoing = function(n) {
    var e, _i, _len, _ref, _results;
    _ref = json.edges;
    _results = [];
    for (_i = 0, _len = _ref.length; _i < _len; _i++) {
      e = _ref[_i];
      if (e.source === n) {
        _results.push(e);
      }
    }
    return _results;
  };

  active = function(n) {
    var e;
    return all((function() {
      var _i, _len, _ref, _results;
      _ref = incoming(n);
      _results = [];
      for (_i = 0, _len = _ref.length; _i < _len; _i++) {
        e = _ref[_i];
        _results.push(e.source.count > 0);
      }
      return _results;
    })());
  };

  holds = function() {
    var n, _i, _len, _ref, _results;
    _ref = json.nodes;
    _results = [];
    for (_i = 0, _len = _ref.length; _i < _len; _i++) {
      n = _ref[_i];
      if (n.group === 0) {
        _results.push(n);
      }
    }
    return _results;
  };

  tasks = function() {
    var n, _i, _len, _ref, _results;
    _ref = json.nodes;
    _results = [];
    for (_i = 0, _len = _ref.length; _i < _len; _i++) {
      n = _ref[_i];
      if (n.group === 1) {
        _results.push(n);
      }
    }
    return _results;
  };

  radius = 15;



  links = svg.selectAll("line.link").data(json.edges).enter().append("line").attr("class", "link").style("stroke", "#000").style("stroke-width", 2);

  circs = svg.selectAll("circle.node").data(holds).enter().append("circle").attr("class", "node").attr("r", radius).style("fill", function(d) {
    if (d.name === '>') {
      return 'lime';
    } else if (d.name === '^') {
      return 'red';
    } else {
      return 'white';
    }
  }).style("stroke", '#000').style("stroke-width", '2');
  

  
  
  
  dead_color = '#333';

  live_color = '#939393';

  click_color = '#999';

  box_color = function(d, i) {
    if (active(d)) {
      return live_color;
    } else {
      return dead_color;
    }
  };

  texts = svg.selectAll("text").data(holds).enter().append("text")
          .text(function(d) {
    if (d.count === 0) {
      return '';
    } else {
      return d.count;
    }
  });

  rects = svg.selectAll("rect.node").data(tasks).enter().append("rect").attr("class", "node").attr("width", radius * 2).attr("height", radius * 2).style("stroke", '#000').style("stroke-width", '2').style("fill", box_color)
    .on('click', function(g, j) {
    if (active(g)) {
      return (function(_this) {
        return function() {
          var e, _i, _j, _len, _len1, _ref, _ref1;
          _ref = incoming(g);
          for (_i = 0, _len = _ref.length; _i < _len; _i++) {
            e = _ref[_i];
            e.source.count -= 1;
          }
          _ref1 = outgoing(g);
          for (_j = 0, _len1 = _ref1.length; _j < _len1; _j++) {
            e = _ref1[_j];
            e.target.count += 1;
          }
          d3.select(_this).style('fill', click_color);
          rects.transition().style('fill', box_color);
          return texts.transition().text(function(d) {
            if (d.count === 0) {
              return '';
            } else {
              return d.count;
            }
          });
        };
      })(this)();
    }
  });

  node = svg.selectAll(".node");

  node.append("title").text(function(d) {
    return d.name;
  });

  force.on("tick", function() {
    texts.attr("x", function(d) {
      return d.x - 5;
    }).attr("y", function(d) {
      return d.y + 5;
    });
    links.attr("x1", function(d) {
      return d.source.x;
    }).attr("y1", function(d) {
      return d.source.y;
    }).attr("x2", function(d) {
      return d.target.x;
    }).attr("y2", function(d) {
      return d.target.y;
    });
    circs.attr("cx", function(d) {
      return d.x;
    }).attr("cy", function(d) {
      return d.y;
    });
    return rects.attr("x", function(d) {
      return d.x - radius;
    }).attr("y", function(d) {
      return d.y - radius;
    });
  });


  
}
