export function semanticNetwork(fD , id){ // function to handle semanticNetwork.
  

  	d3.select(id).append("svg")
  			.attr( 'id', 'svgg')
  			.attr("width",900)
  			.attr("height",600);
  
      var svg = d3.select("#svgg"),
        width = +svg.attr("width"),
        height = +svg.attr("height");

      var container = svg.append("g");
      svg.call(
        d3.zoom()
            .scaleExtent([.1, 4])
            .on("zoom", function() { container.attr("transform", d3.event.transform); }));

    var color = d3.scaleOrdinal(d3.schemePaired);

    var simulation = d3.forceSimulation()
        .force("link", d3.forceLink().distance(10).strength(0.5))
        .force("charge", d3.forceManyBody())
        .force("center", d3.forceCenter(width / 2, height / 2));

    d3.json(fD).then(function(graph){
      console.log("ad");


      var nodes = graph.nodes,
          nodeById = d3.map(nodes, function(d) { return d.id; }),
          links = graph.links,
          bilinks = [];

      links.forEach(function(link) {
        var s = link.source = nodeById.get(link.source),
            t = link.target = nodeById.get(link.target),
            i = {}; // intermediate node
        nodes.push(i);
        links.push({source: s, target: i}, {source: i, target: t});
        bilinks.push([s, i, t]);
      });

      var link = container.selectAll(".linkha")
        .data(bilinks)
        .enter().append("path")
          .attr("class", "linkha");

      var nodez = container.selectAll(".nodeha")
        .data(nodes.filter(function(d) { return d.id; }));

      var gg = nodez.enter().append("g");

      var node = gg.append("circle")
          .attr("class", "nodeha")
          .attr("r", 7)
          .attr("fill", function(d) { return color(d.group); })
          .call(d3.drag()
              .on("start", dragstarted)
              .on("drag", dragged)
              .on("end", dragended));

      var texti = gg.append("text")
            .attr("y", function(d, i){ return -10;})
            .text(function(d){return d.id})
            .attr('text-anchor', 'middle')
            .attr('alignment-baseline', 'middle')
            .style('font-size', 12 + 'px');


      node.append("title")
          .text(function(d) { return d.id; });

      simulation
          .nodes(nodes)
          .on("tick", ticked);

      simulation.force("link")
          .links(links);

      function ticked() {
        link.attr("d", positionLink);
        node.attr("transform", positionNode);
        texti.attr("transform", positionNode);
      }
    });

    function positionLink(d) {
      return "M" + d[0].x + "," + (d[0].y)
           + "S" + d[1].x + "," + (d[1].y)
           + " " + d[2].x + "," + (d[2].y);
    }

    function positionNode(d) {
      return "translate(" + d.x + "," + (d.y) + ")";
    }

    function dragstarted(d) {
      if (!d3.event.active) simulation.alphaTarget(0.3).restart();
      d.fx = d.x, d.fy = d.y;
    }

    function dragged(d) {
      d.fx = d3.event.x, d.fy = d3.event.y;
    }

    function dragended(d) {
      if (!d3.event.active) simulation.alphaTarget(0);
      d.fx = null, d.fy = null;
    }
}
  