import { load } from './systemdynamicsHead.js';

export function systemDynamics(fD , id , type){ // function to handle systemDynamics.
  
  var div = d3.select(id)
      .append('div')
  		.attr('id', "systemDynamicss");
  		

	div.append("div")
    .attr('id', "myDiagram")
		.style('border', "solid 1px black")
		.style('width', "600px")
		.style('height', "500px");

	var div2 = div.append("div");

	div2.append("input")
    .attr( 'type', 'button')
		.attr( 'value', 'draw')
		.on("click", load);

	div2.append("text")
  	.html( ' Diagram Model data in JSON format:');

	if (type==0 )
  {
    div.append("foreignObject")
      .append("xhtml:body")
      .attr('xmlns','http://www.w3.org/1999/xhtml')
      .append('textarea')
      .property('value',
            `{ "class": "go.GraphLinksModel",
              "linkLabelKeysProperty": "labelKeys",
              "nodeDataArray": [
            {"key":"grass", "category":"stock", "label":"Grass", "loc":"30 220", "label_offset":"0.5 0.5 0 30"},
            {"key":"cloud1", "category":"cloud", "loc":"200 220"},
            {"key":"sheep", "category":"stock", "label":"Sheep", "loc":"30 20","label_offset":"0.5 0.5 0 -30"},
            {"key":"cloud2", "category":"cloud", "loc":"200 20"},
            {"key":"cloud3", "category":"cloud", "loc":"-150 220"},
            {"key":"grass_loss", "category":"valve", "label":"grass_loss","label_offset":"0.5 0.5 0 20" },
            {"key":"grazing", "category":"valve", "label":"grazing","label_offset":"0.5 0.5 45 0" },
            {"key":"growth", "category":"valve", "label":"growth","label_offset":"0.5 0.5 0 20" },
            {"key":"sheep_loss", "category":"valve",  "label":"sheep_loss","label_offset":"0.5 0.5 0 20" },
            {"key":"k1", "category":"variable",  "label":"good weather", "loc": "-80 100"},
            {"key":"k2", "category":"variable",  "label":"bad weather", "loc": "100 150"},
            {"key":"k3", "category":"variable",  "label":"wolves", "loc": "150 -40"}
              ],
              "linkDataArray": [
            {"from":"grass", "to":"cloud1", "category":"flow", "labelKeys":[ "grass_loss" ]},
            {"from":"sheep", "to":"cloud2", "category":"flow", "labelKeys":[ "sheep_loss" ]},
            {"from":"grass", "to":"sheep", "category":"flow", "labelKeys":[ "grazing" ]},
            {"from":"cloud3", "to":"grass", "category":"flow", "labelKeys":[ "growth" ]},
            {"from":"grass", "to":"grass_loss", "category":"influence"},
            {"from":"sheep", "to":"sheep_loss", "category":"influence"},
            {"from":"grass", "to":"growth", "category":"influence"},
            {"from":"grass", "to":"grazing", "category":"influence"},
            {"from":"sheep", "to":"grazing", "category":"influence"},
            {"from":"k1", "to":"growth", "category":"influence"},
            {"from":"k1", "to":"grazing", "category":"influence"},
            {"from":"k2", "to":"grass_loss", "category":"influence"},
            {"from":"k3", "to":"sheep_loss", "category":"influence"}
              ]
            }`
            )
      .style("font-size" , "12px")
      .attr('id','mySavedModel')
      .attr('rows','10')
      .style('width','600px')
      .style('height','400px');
  }
  else if (type==1)
  {
    div.append("foreignObject")
      .append("xhtml:body")
      .attr('xmlns','http://www.w3.org/1999/xhtml')
      .append('textarea')
      .property('value',
            `{ "class": "GraphLinksModel",
              "linkLabelKeysProperty": "labelKeys",
              "nodeDataArray": [ 
            {"key":"stock2", "category":"stock", "label":"1. the problem situation unstructured", "loc":"-263 -118", "label_offset":"0.5 0.5 9 -35"},
            {"key":"stock3", "category":"stock", "label":"2. the problem situation expressed", "loc":"-220 25", "label_offset":"0.5 0.5 -31 -27"},
            {"key":"stock4", "category":"stock", "label":"3. root definition of relevant systems", "loc":"-312 131", "label_offset":"0.5 0.5 7 37"},
            {"key":"stock17", "category":"stock", "label":"4. conceptual models", "loc":"-33 127"},
            {"key":"stock18", "category":"stock", "label":"4a. formal system concept", "loc":"-107 225", "label_offset":"0.5 0.5 5 40"},
            {"key":"stock19", "category":"stock", "label":"4b. other system thinking", "loc":"23 217", "label_offset":"0.5 0.5 23 36"},
            {"key":"stock20", "category":"stock", "label":"5. comparison of 4 with 2", "loc":"-146 24", "label_offset":"0.5 0.5 53 37"},
            {"key":"stock21", "category":"stock", "label":"6. feasible changes", "loc":"-22 -65"},
            {"key":"stock22", "category":"stock", "label":"7. action to improve problem situation", "loc":"-135 -100", "label_offset":"0.5 0.5 47 -35"}
             ],
              "linkDataArray": [ 
            {"category":"influence", "text":"influence", "from":"stock2", "to":"stock3", "labelKeys":[]},
            {"category":"influence", "text":"influence", "from":"stock3", "to":"stock4", "labelKeys":[]},
            {"category":"influence", "text":"influence", "from":"stock4", "to":"stock17", "labelKeys":[]},
            {"category":"influence", "text":"influence", "from":"stock18", "to":"stock17", "labelKeys":[]},
            {"category":"influence", "text":"influence", "from":"stock19", "to":"stock17", "labelKeys":[]},
            {"category":"influence", "text":"influence", "from":"stock17", "to":"stock20", "labelKeys":[]},
            {"category":"influence", "text":"influence", "from":"stock20", "to":"stock21", "labelKeys":[]},
            {"category":"influence", "text":"influence", "from":"stock21", "to":"stock22", "labelKeys":[]}
              ]
					  }`
            )
      .style("font-size" , "12px")
      .attr('id','mySavedModel')
      .attr('rows','10')
      .style('width','600px')
      .style('height','400px');
    
  }
  else if (type==2)
  {
    div.append("foreignObject")
      .append("xhtml:body")
      .attr('xmlns','http://www.w3.org/1999/xhtml')
      .append('textarea')
      .property('value',
      `{ "class": "GraphLinksModel",
        "linkLabelKeysProperty": "labelKeys",
        "nodeDataArray": [ 
      {"key":"stock1", "category":"stock", "label":"all students are creative", "loc":"-107 -19", "label_offset":"0.5 0.5 3 -32"},
      {"key":"stock4", "category":"stock", "label":"no students are creative", "loc":"115 -17", "label_offset":"0.5 0.5 6 -31"},
      {"key":"stock5", "category":"stock", "label":"some students are creative", "loc":"-104 198", "label_offset":"0.5 0.5 -2 34"},
      {"key":"stock6", "category":"stock", "label":"not all students are creative", "loc":"123 200", "label_offset":"0.5 0.5 1 34"},
      {"category":"valve", "key":-5, "label":"SubContraries", "loc":"9 199", "label_offset":"0.5 0.5 1 -20"},
      {"category":"valve", "key":-6, "label":"Subaltern", "loc":"-106 89"},
      {"category":"valve", "key":-7, "label":"Contraries", "loc":"4 -18"},
      {"category":"valve", "key":-8, "label":"subaltern", "loc":"119 91"},
      {"category":"valve", "key":-9, "label":"Contradictory", "loc":"8 90"}
       ],
        "linkDataArray": [ 
      {"category":"flow", "text":"flow", "from":"stock4", "to":"stock5", "labelKeys":[]},
      {"category":"flow", "text":"flow", "from":"stock5", "to":"stock6", "labelKeys":[ -5 ]},
      {"category":"flow", "text":"flow", "from":"stock1", "to":"stock5", "labelKeys":[]},
      {"category":"flow", "text":"flow", "from":"stock4", "to":"stock1", "labelKeys":[ -7 ]},
      {"category":"flow", "text":"flow", "from":"stock6", "to":"stock4", "labelKeys":[ -8 ]},
      {"category":"flow", "text":"flow", "from":"stock1", "to":"stock6", "labelKeys":[ -9 ]}
        ]
      }`
      )
      .style("font-size" , "12px")
      .attr('id','mySavedModel')
      .attr('rows','10')
      .style('width','600px')
      .style('height','400px');
  }
  else if (type==3)
  {
    div.append("foreignObject")
      .append("xhtml:body")
      .attr('xmlns','http://www.w3.org/1999/xhtml')
      .append('textarea')
      .property('value',
      `{ "class": "GraphLinksModel",
        "linkLabelKeysProperty": "labelKeys",
        "nodeDataArray": [ 
      {"key":"stock1", "category":"stock", "label":"Thesis", "loc":"124 29", "label_offset":"0.5 0.5 0 2"},
      {"key":"stock2", "category":"stock", "label":"why?", "loc":"-5 159", "label_offset":"0.5 0.5 2 0"},
      {"key":"stock3", "category":"stock", "label":"How?", "loc":"124 161", "label_offset":"0.5 0.5 2 1"},
      {"key":"stock4", "category":"stock", "label":"where?", "loc":"266 163", "label_offset":"0.5 0.5 0 1"},
      {"key":"stock5", "category":"stock", "label":"A", "loc":"-93 335", "label_offset":"0.5 0.5 2 1"},
      {"key":"stock6", "category":"stock", "label":"B", "loc":"16 337", "label_offset":"0.5 0.5 0 0"},
      {"key":"stock7", "category":"stock", "label":"E", "loc":"364 338", "label_offset":"0.5 0.5 2 4"},
      {"key":"stock8", "category":"stock", "label":"D", "loc":"275 338", "label_offset":"0.5 0.5 0 3"},
      {"key":"stock9", "category":"stock", "label":"C", "loc":"128 337", "label_offset":"0.5 0.5 0 3"},
      {"key":"variable1", "category":"variable", "label":"inductive thinking", "loc":"-20 241"},
      {"key":"variable2", "category":"variable", "label":"deductive thinking", "loc":"200 366"},
      {"key":"variable4", "category":"variable", "label":"inductive thinking", "loc":"119 93"},
      {"key":"variable6", "category":"variable", "label":"inductive thinking", "loc":"190 247"},
      {"key":"variable7", "category":"variable", "label":"inductive thinking", "loc":"318 263"}
       ],
        "linkDataArray": [ 
      {"category":"flow", "text":"flow", "from":"stock7", "to":"stock4", "labelKeys":[]},
      {"category":"flow", "text":"flow", "from":"stock8", "to":"stock3", "labelKeys":[]},
      {"category":"flow", "text":"flow", "from":"stock5", "to":"stock2", "labelKeys":[]},
      {"category":"flow", "text":"flow", "from":"stock6", "to":"stock2", "labelKeys":[]},
      {"category":"flow", "text":"flow", "from":"stock2", "to":"stock1", "labelKeys":[]},
      {"category":"flow", "text":"flow", "from":"stock3", "to":"stock1", "labelKeys":[]},
      {"category":"flow", "text":"flow", "from":"stock4", "to":"stock1", "labelKeys":[]},
      {"category":"influence", "text":"influence", "from":"stock9", "to":"stock8", "labelKeys":[]}
       ]}`
      )
      .style("font-size" , "12px")
      .attr('id','mySavedModel')
      .attr('rows','10')
      .style('width','600px')
      .style('height','400px');
  }
  else if (type==4)
  {
    div.append("foreignObject")
      .append("xhtml:body")
      .attr('xmlns','http://www.w3.org/1999/xhtml')
      .append('textarea')
      .property('value',
      `{ "class": "GraphLinksModel",
        "linkLabelKeysProperty": "labelKeys",
        "nodeDataArray": [ 
      {"key":"stock1", "category":"stock", "label":"Cause", "loc":"-205 95"},
      {"key":"stock2", "category":"stock", "label":"effect1", "loc":"-61 24"},
      {"key":"stock3", "category":"stock", "label":"effect2", "loc":"-62 101"},
      {"key":"stock4", "category":"stock", "label":"effect3", "loc":"-61 182"},
      {"key":"stock5", "category":"stock", "label":"effect2.2", "loc":"110 107"},
      {"key":"stock6", "category":"stock", "label":"effect2.1", "loc":"111 32"},
      {"key":"stock7", "category":"stock", "label":"effect2.3", "loc":"111 183"}
       ],
        "linkDataArray": [ 
      {"category":"flow", "text":"flow", "from":"stock1", "to":"stock4", "labelKeys":[]},
      {"category":"flow", "text":"flow", "from":"stock1", "to":"stock3", "labelKeys":[]},
      {"category":"flow", "text":"flow", "from":"stock1", "to":"stock2", "labelKeys":[]},
      {"category":"flow", "text":"flow", "from":"stock3", "to":"stock6", "labelKeys":[]},
      {"category":"flow", "text":"flow", "from":"stock3", "to":"stock5", "labelKeys":[]},
      {"category":"flow", "text":"flow", "from":"stock3", "to":"stock7", "labelKeys":[]}
       ]}`
      )
      .style("font-size" , "12px")
      .attr('id','mySavedModel')
      .attr('rows','10')
      .style('width','600px')
      .style('height','400px');
  }
  
  
}