import { d3box } from './box.js';
export function tukeyBox(fD , id , title){ // function to handle tukeyBox.
  
    
  
  	var labels = true; // show the text labels beside individual boxplots?

    var margin = {top: 60, right: 50, bottom: 70, left: 60};
    var  width = 800 - margin.left - margin.right;
    var height = 700 - margin.top - margin.bottom;

    var min = Infinity,
        max = -Infinity;

      var csv=fD;
  		var titles = Object.keys(csv[0]);
  		var titleslength = titles.length;
  		console.log(titles);
  
      // using an array of arrays with
      // data[n][2] 
      // where n = number of columns in the csv file 
      // data[i][0] = name of the ith column
      // data[i][1] = array of values of ith column

      var data = [];
  		for(let i=0;i<titleslength;i++)
        data[i] = [];
  
			for(let i=0;i<titleslength;i++) // add here the header of the csv file
      {
        data[i][0] = titles[i];
        data[i][1] = [];
      }



      csv.forEach(function(x) {
        
        var v = [];
        for(let i=0;i<titleslength;i++) 
        {
          v[i] = Math.floor(x[titles[i]]);
        }

        var rowMax = Math.max(...v);
        var rowMin = Math.min(...v);

        for(let i=0;i<titleslength;i++) 
        {
          data[i][1].push(v[i]);
        }

        if (rowMax > max) max = rowMax;
        if (rowMin < min) min = rowMin;	
      });

      var chart = d3box()
        .whiskers(iqr(1.5))
        .height(height)	
        .domain([min, max])
        .showLabels(labels);

      var svg = d3.select(id).append("svg")
        .attr("width", width + margin.left + margin.right+100)
        .attr("height", height + margin.top + margin.bottom+100)
        .attr("class", "box")    
        .append("g")
        .attr("transform", "translate(" + margin.left + "," + margin.top + ")");


      // the x-axis
      var x = d3.scaleBand()	   
        .domain( data.map(function(d) { console.log(d); return d[0] } ) )	    
        .rangeRound([0 , width], 0.7, 0.3); 		

  
      var xAxis = d3.axisBottom(x);

      // the y-axis
      var y = d3.scaleLinear()
        .domain([min, max])
        .range([height + margin.top, 0 + margin.top]);

      var yAxis = d3.axisLeft(y);

      // draw the boxplots	
      svg.selectAll(".box")	   
          .data(data)
        .enter().append("g")
        .attr("transform", function(d) { return "translate(" +  (x(d[0])+x.bandwidth()/4)  + "," + margin.top + ")"; } )
          .call(chart.width(x.bandwidth()/2)); 


      // add a title
      svg.append("text")
            .attr("x", (width / 2))             
            .attr("y", 0 + (margin.top / 2))
            .attr("text-anchor", "middle")  
            .style("font-size", "18px")  
            .text(title);

       // draw y axis
      svg.append("g")
            .attr("class", "y axis")
            .call(yAxis);
        // .append("text") // and text1
        //   .attr("transform", "rotate(-90)")
        //   .attr("y", 6)
        //   .attr("dy", ".71em")
        //   .style("text-anchor", "end")
        //   .style("font-size", "16px") 
        //   .text("Revenue in €");		

      // draw x axis	
      svg.append("g")
          .attr("class", "x axis")
          .attr("transform", "translate(0," + (height  + margin.top + 10) + ")")
          .call(xAxis);
        // .append("text")             // text label for the x axis
        //     .attr("x", (width / 2) )
        //     .attr("y",  6 )
        // .attr("dy", ".71em")
        //     .style("text-anchor", "middle")
        // .style("font-size", "16px") 
        //     .text("Quarter"); 

    // Returns a function to compute the interquartile range.
    function iqr(k) {
      return function(d, i) {
        var q1 = d.quartiles[0],
            q3 = d.quartiles[2],
            iqr = (q3 - q1) * k,
            i = -1,
            j = d.length;
        while (d[++i] < q1 - iqr);
        while (d[--j] > q3 + iqr);
        return [i, j];
      };
    }
  